> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/search/search-replace.md).

# Search and Replace Text within WebViewer, DOCX Editor, and Spreadsheet Editor

Search and Replace Text within WebViewer, DOCX Editor, and Spreadsheet Editor through the UI or programmatically.

{% hint style="info" %}
Search and replace for PDF documents in the WebViewer requires the [Content Edit](/web/edit-page-content/text-edit.md) add-on.
{% endhint %}

All three document viewers contain built in UIs for performing the search and replace functionality in their respective file types.

![WebViewer Search and Replace UI](https://3532544125-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FX9YnTSKIHvV7m0A36LbO%2Fuploads%2Fgit-blob-6022147f6973adf0c481c0c41f03237826841035%2F4717b47c7c3a15e1cc8fe95fe469e0ed7041a0f5-1239x607.png?alt=media)

Search and replace can also be handled uniformly across all three viewers using APIs:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const documentViewer = instance.Core.documentViewer;
  
  documentViewer.addEventListener('documentLoaded', async () => {
    const searchStream = documentViewer.search('search_term'); // Setting up stream using your string to search.
    const searchResults = await searchStream.getAll(); // Wait for all results.
    await documentViewer.replace(searchResults, ' replace_term'); // Replace results using string.
  });
});
```

{% endcode %}
{% endtab %}
{% endtabs %}

[DocumentViewer.search](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#search) [DocumentViewer.replace](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#replace)

Here is another sample that replaces all of the search results found only on page one:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const documentViewer = instance.Core.documentViewer;
  
  documentViewer.addEventListener('documentLoaded', async () => {
    const searchStream = documentViewer.search('search_term'); // Setting up stream using your string to search.
    const searchResults = await searchStream.getAll(); // Wait for all results.
    const firstPageResults = searchResults.filter(result => result.pageNum === 1); // Search results can be filtered or reordered but not modified. 
    await documentViewer.replace(firstPageResults, ' replace_term'); // Replace results using string.
  });
}); 
```

{% endcode %}
{% endtab %}
{% endtabs %}

[DocumentViewer.search](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#search) [DocumentViewer.replace](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#replace)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/search/search-replace.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
